<?php
namespace Ak\App;

use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Throwable;
use Zend\Stratigility\MiddlewarePipeInterface;

/**
 * Interface ApplicationInterface
 *
 * @package Ak\App
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/app
 */
interface ApplicationInterface
{
    /**
     * Da li je aplikacija u development modu?
     *
     * @return bool
     */
    public function isDevelopment(): bool;

    /**
     * Vraća konfiguraciju aplikacije.
     *
     * @return array
     */
    public function getConfig(): array;

    /**
     * Vraća glavni container aplikacije.
     *
     * @return ContainerInterface
     */
    public function getContainer(): ContainerInterface;

    /**
     * Vraća glavni pipe aplikacije.
     *
     * @return MiddlewarePipeInterface
     */
    public function getPipe(): MiddlewarePipeInterface;

    /**
     * Pokreće aplikaciju.
     */
    public function run(): void;

    /**
     * Stvara HTTP odgovor od exceptiona.
     *
     * @param Throwable $e
     * @return ResponseInterface
     */
    public function createErrorResponse(Throwable $e): ResponseInterface;
}